# -*- coding: utf-8 -*-
#---------------------------------------------------------------------
# License: GPL (http://www.gnu.org/licenses/gpl-3.0.html)
# Gracias a las librerías de Jesús (www.mimediacenter.info)
#---------------------------------------------------------------------


import os, sys, urllib, urllib2, re, shutil
import xbmc, xbmcgui, xbmcaddon, xbmcplugin
import json
import plugintools
from core.item import Item
from core import scrapertools

addonName           = xbmcaddon.Addon().getAddonInfo("name")
addonVersion        = xbmcaddon.Addon().getAddonInfo("version")
addonId             = xbmcaddon.Addon().getAddonInfo("id")
addonPath           = xbmcaddon.Addon().getAddonInfo("path")


home = xbmcaddon.Addon().getAddonInfo('path')+'/'
playlists = xbmc.translatePath(os.path.join('special://userdata/playlists', ''))
temp = xbmc.translatePath(os.path.join('special://userdata/playlists/tmp/', ''))
addons = xbmc.translatePath(os.path.join('special://home/addons/', ''))
mi_userdata = xbmc.translatePath(os.path.join("special://home/userdata/addon_data/plugin.video.pelisalacarta/", ''))
kodi = xbmc.translatePath(os.path.join('special://home/', ''))
backup_fich = xbmc.translatePath(os.path.join('special://home/userdata/addon_data/plugin.video.pelisalacarta/downloads/', ''))

# Comprobamos qué versión es la más reciente
def check_update(url):
    #Este Trae la vesión v01 de los ficheros, al no existir la 1ª vez, los añade pero no saca copia de seguridad
    #Item.url = "https://dl.dropbox.com/s/4wbc6zzm87n2rv4/UpdaterPrueba.txt"

    #Este es para la 2ª vez (lo desmarco, y marco el 1º)... con este, al ya existir los ficheros, los debe sustituir y dejar una copia de seguridad del anterior.
    #Item.url = "https://dl.dropbox.com/s/xbeosjclg2rad15/UpdaterPrueba2.txt"

    # Creamos las carpetas si no existen
    if not os.path.exists(playlists):
        os.mkdir(playlists)
    if not os.path.exists(temp):
        os.mkdir(temp)
    if not os.path.exists(backup_fich):
        os.mkdir(backup_fich)


    Item.url= url
    data = scrapertools.cache_page(Item.url)
    plugintools.log("*************************** "+data)	

    plotter="";datamovie = {}
    subchannel = plugintools.find_multiple_matches(data, '<subchannel>(.*?)</subchannel>')
    i = 0
    plugintools.log("***************************I= ")	
    plugintools.log(str(len(subchannel)))	
    plugintools.log("***************************I= "+str(i))

    fich_verif = xbmc.translatePath(os.path.join(mi_userdata, "verif_upd.json"))
    plugintools.log("fich_verif: " + fich_verif)
    if os.path.exists(fich_verif):  # Si ya hay fichero de verificación, leo la versión
        dict_versions = json.loads(open(fich_verif, "r").read())
    else:
        dict_versions = {}

    for entry in subchannel:
        #try:
        plugintools.log("********************entry: "+entry+"***********************")
        title = plugintools.find_single_match(entry, '<name>(.*?)</name>')
        url = plugintools.find_single_match(entry, '<url>(.*?)</url>')
        thumbnail = plugintools.find_single_match(entry, '<thumbnail>(.*?)</thumbnail>')
        version = plugintools.find_single_match(entry, '<version>(.*?)</version>')
        nom_fichero = plugintools.find_single_match(entry, '<fichero>(.*?)</fichero>')
        fanart = plugintools.find_single_match(entry, '<fanart>(.*?)</fanart>')
        forzado = plugintools.find_single_match(entry, '<forzado>(.*?)</forzado>')
        clase = plugintools.find_single_match(entry, '<clase>(.*?)</clase>').upper()
        ruta = plugintools.find_single_match(entry, '<ruta>(.*?)</ruta>')
        datamovie["Plot"] = '[COLOR white]'+plugintools.find_single_match(entry, '<changelog>(.*?)</changelog>')+'[/COLOR]'

        fichero = xbmc.translatePath(os.path.join(kodi, ruta, nom_fichero))

        '''actualizo = True
        if os.path.exists(fich_verif):  # Si ya hay fichero de verificación, leo la ultima versión
            ult_version = dict_versions.get(title, "v0.0")

            if version == ult_version: # Si las versiones fueran numericas podriamos compara si version > ult_version
                plugintools.log("*************LA VERSION ES IGUAL!!!!**********************")

                if os.path.exists(fichero):  # Ya tiene ese fichero/plugin de antes
                   actualizo = False
                else:
                   actualizo = True  # Por algún motivo, aunq existe el de verificación, se ha borrado el fichero... así q lo repongo
            else:
                actualizo = True
        else:
            plugintools.log("************* no existe el fichero de verificacion: " + fich_verif)


            if os.path.exists(fichero):  # Ya tiene ese fichero/plugin de antes
                 if forzado.upper() == "SI":  # Anunq ya lo tenga, considero necesario cambiarlo x el mío
                     actualizo = True
                 else:                        # No considero necesario reemplazarlo.
                     actualizo = False
            else:                            # Si no lo tiene, evidentemente lo instalo
                 actualizo = True
        '''

        actualizo = False
        # Obtenemos la ultima version del archivo verif_upd.json...
        # ... si no existe el archivo o no tenemos version guardada para title devolvemos la version minima 'v0.0'
        ult_version = dict_versions.get(title, "v0.0")
        plugintools.log("*************version UpdaterPrueba: " + str(version))
        plugintools.log("*************ult_version verif_upd.json: " + str(ult_version))

        # Si las versiones son distintas: actualizarlo
        # Atencion: Si las versiones fueran numericas podriamos compara si version > ult_version y actualizar solo si
        # la nueva version es mayor q la ult_version guardada
        if version != ult_version:
            actualizo = True

        # Si el fichero ha actualizar no existe: instalarlo
        if not os.path.exists(fichero):
            actualizo = True

        # Caso especial (no entiendo muy bien el 'forzado', pero lo mantengo para ser lo mas fiel posible a tu codigo)...
        # Si no existe archivo de verificacion (o no hay version guardada de title) Y el fichero existe...
        if ult_version == 'v0.0' and os.path.exists(fichero):
            if forzado.upper() == "SI":  # Anunq ya lo tenga, considero necesario cambiarlo x el mío
                actualizo = True


        if actualizo:
            if clase == "FICHERO":
                plugintools.log("*************VOY A ENTRAR*****************")
                ret = actualiza_fich(title, nom_fichero, ruta, url)

                if ret == 1: #Actualizado con exito!!!
                    dict_versions[title] = version
                    plugintools.log("************* I=I+1 *****************")
                    i = i + 1


    # Creamos/actualizamos el archivo verif_upd.json
    json_data = json.dumps(dict_versions)
    try:
        open(fich_verif, "w").write(json_data)
    except EnvironmentError:
        logger.info("[config.py] ERROR al salvar el archivo: {0}".format(fich_verif))


        '''except: #Atencion no es buena idea poner esto durante la depuracion, en caso de error te vuelve loco !!!!
            pass    '''

    if i > 0:
        xbmcgui.Dialog().ok( "¡¡ATENCIÓN" , "Se han producido [COLOR red]"+str(i)+" ACTUALIZACIONES[/COLOR]... se recomienda [COLOR red]REINICIAR[/COLOR] el sistema" )

    return i


def actualiza_fich(title, nom_fichero, ruta, url):
    fich_destino = xbmc.translatePath(os.path.join(backup_fich, nom_fichero))
    plugintools.log("*************fich destino: "+fich_destino)
    #stop()
    #if os.path.isfile(fich_destino):
    '''if os.path.exists(fich_destino):
        plugintools.log("*************YA EXISTE EL FICH. DESTINO ASI Q LO BORRO**************")
        os.remove(fich_destino)
        origen = xbmc.translatePath(os.path.join(kodi, ruta, nom_fichero))
        #destino = xbmc.translatePath(os.path.join(backup_fich + ruta +'/' + nom_fichero))
        destino = xbmc.translatePath(os.path.join(backup_fich, nom_fichero))
        shutil.copyfile(origen , destino)  # Hago el backup del fichero

    else:
        plugintools.log("************NO EXISTE EL FICH DESTINO ASÍ Q LO COPIO**************")
        origen = xbmc.translatePath(os.path.join(kodi, ruta, nom_fichero))
        plugintools.log("************FICHERO ORIGEN: "+origen+"**************")
        if os.path.exists(origen):
            plugintools.log("************SI ENTRA AQUÍ ES XQ YA EXISTE EN EL PROGRAMA... PERO PUEDE SER NUEVO, ASI Q NO HACE EL COPY PUES DA ERROR**************")
            destino = xbmc.translatePath(os.path.join(backup_fich, nom_fichero))
            shutil.copyfile(origen , destino)  # Hago el backup del fichero
    '''
    origen = xbmc.translatePath(os.path.join(kodi, ruta, nom_fichero))
    if os.path.exists(origen):
        #Si el fichero a actualizar ya existe guardar una copia en backup_fich, sobreescribiendola en caso de existir
        destino = xbmc.translatePath(os.path.join(backup_fich, nom_fichero))
        shutil.copyfile(origen, destino)  # Hago el backup del fichero
        plugintools.log("************Creadad copia de seguridad**************")


    plugintools.log("************DESCARGO E INICIO ACTUALIZACIÓN**************")
    #Ahora descargo el fichero nuevo y lo pongo en su sitio
    progreso = xbmcgui.DialogProgressBG()
    progreso.create("Iniciando actualización... " , nom_fichero )
    #yesno = 0

    r = urllib2.urlopen(url)
    contenido = r.read()
    r.close()
    origen = xbmc.translatePath(os.path.join(temp, nom_fichero))
    destino = xbmc.translatePath(os.path.join(kodi, ruta, nom_fichero))
    plugintools.log("*************origen: "+origen)
    plugintools.log("*************destino: "+destino)
    plugintools.log("*************url: "+url)

    f = open(origen, "wb")
    f.write(contenido)
    f.close()

    plugintools.log("************LO INTENTO COPIAR**************")
    try:
        progreso.update(50, "Copiando archivo... " , nom_fichero)
        shutil.copyfile(origen, destino)
        progreso.update(100, "Actualización completada! " , nom_fichero)

        os.remove(origen)
        xbmc.executebuiltin(
            "Notification(%s,%s,%i,%s)" % (addonName, "Actualización completada!", 3, home + 'icon.png'))
        progreso.close()
        plugintools.log("Completada la actualización de " + nom_fichero)
        return 1

    except:
        progreso.close()
        plugintools.log("************Error al sobreescribir!**************")
        return 0



	
			
